
%PROLOG%


/*----------------------*/
/* Constant definitions */ 
/*----------------------*/

#define WIN_CLASS_NAME     "WC_CLIENT"   /* Client window class name */
#define BUFFERSIZE         60            /* Maximum buffer length */
#define THREAD_STACK_SIZE  8192          /* Stack size for secondary threads */
#define TUTORIAL_FILE      "TUTOR.INF"   /* Tutorial INF file name */
#define TUTORIAL_PROGRAM   "view.exe"    /* Tutorial command name */
#define TUTORIAL_PROGRAM2  "viewdoc.exe" /* Supporting tutorial program */
#define HELP_FILE_NAME     "HELP.HLP"    /* Help file name */
#define IDH_GENHELP_RESNO  100           /* General help resource number in HLP file */
#define IDH_FILEOPEN_RESNO 135           /* File open dlg help resource number in HLP file*/
#define IDH_SAVEAS_RESNO   155           /* Save as dlg help resource number in HLP file*/

/*--------------------------*/
/* Identifier constants     */
/*--------------------------*/

/* Window IDs */
#define IDW_BASE                    100
#define IDW_FRAME_WINDOW            101  
#define IDW_MESSAGE_BOX             102
                                    
/* Icon IDs */                      
#define IDI_PMICON                  900

/* Menu item IDs */
#define IDM_BASE                    1000
#define IDM_FILE                    IDM_BASE + 1
#define IDM_FILE_OPEN               IDM_BASE + 2
#define IDM_FILE_SAVE               IDM_BASE + 3 
#define IDM_FILE_SAVEAS             IDM_BASE + 4 
#define IDM_FILE_PRINT              IDM_BASE + 5 
#define IDM_FILE_CLOSE              IDM_BASE + 6 
#define IDM_EDIT                    IDM_BASE + 7
#define IDM_EDIT_UNDO               IDM_BASE + 8
#define IDM_EDIT_COPY               IDM_BASE + 9
#define IDM_EDIT_CUT                IDM_BASE + 10
#define IDM_EDIT_PASTE              IDM_BASE + 11
#define IDM_EDIT_FIND               IDM_BASE + 12
#define IDM_EDIT_FINDNEXT           IDM_BASE + 13
#define IDM_HELP                    IDM_BASE + 14
#define IDM_HELP_INDEX              IDM_BASE + 15
#define IDM_HELP_GENERAL            IDM_BASE + 16
#define IDM_HELP_USING              IDM_BASE + 17
#define IDM_HELP_TUTORIAL           IDM_BASE + 18
#define IDM_HELP_PRODINFO           IDM_BASE + 19  

/* Dialog and dialog controls IDs */
#define IDD_BASE                    2000
#define IDD_PROD_INFO               2001
#define IDT_PRODINFO_TEXT1          IDD_BASE + 2 
#define IDT_PRODINFO_TEXT2          IDD_BASE + 3 
#define IDT_PRODINFO_TEXT3          IDD_BASE + 4 
#define IDT_PRODINFO_TEXT4          IDD_BASE + 5 
#define IDT_PRODINFO_TEXT5          IDD_BASE + 6
#define IDP_PRODINFO_OK             IDD_BASE + 7 

/* Do not change the following numbers */
#define IDD_FILEOPEN_DLG            256 /* Standard File open and Save as dialog id */
#define IDD_SAVEAS_DLG              256 /* Standard File open and Save as dialog id */ 
#define DID_HELP                    267 /* OK button of file open and save as dialogs */ 


/* Help table IDs */
#define IDH_BASE                    5000
#define IDH_MAIN_HELPTABLE          5001          
#define IDH_SUBTABLE_FRAME          5002
#define IDH_FILEOPEN_DLG            5003
#define IDH_SAVEAS_DLG              5004


/* String IDs */
#define IDS_BASE                    300
#define IDS_TITLE                   IDS_BASE + 1
#define IDS_EXIT                    IDS_BASE + 2
#define IDS_FILE_OPEN               IDS_BASE + 3 
#define IDS_ERROR_OPENING_FILE      IDS_BASE + 4
#define IDS_OPEN_FILE               IDS_BASE + 5
#define IDS_SAVE_FILE               IDS_BASE + 6
#define IDS_ERROR_NO_FILE_LOADED    IDS_BASE + 7
#define IDS_PRINT_FILE              IDS_BASE + 8
#define IDS_UNDO                    IDS_BASE + 9
#define IDS_COPY                    IDS_BASE + 10
#define IDS_CUT                     IDS_BASE + 11
#define IDS_PASTE                   IDS_BASE + 12
#define IDS_FIND                    IDS_BASE + 13
#define IDS_FINDNEXT                IDS_BASE + 14
#define IDS_SAVEAS                  IDS_BASE + 15
#define IDS_SAVE                    IDS_BASE + 16
#define IDS_FILE_SAVED              IDS_BASE + 17
#define IDS_FILE_OPENED             IDS_BASE + 18
#define IDS_ERROR_CREATING_HELP     IDS_BASE + 19
#define IDS_ERROR_NO_HELP           IDS_BASE + 20
#define IDS_ERROR_VIEW_NOT_FOUND    IDS_BASE + 21
#define IDS_TUTORIAL_TITLE          IDS_BASE + 22
#define IDS_ERROR_STARTING_TUTORIAL IDS_BASE + 23
#define IDS_ERROR_NO_TUTORIAL       IDS_BASE + 24
#define IDS_HELP_INDEX              IDS_BASE + 25  
#define IDS_HELP_GENERAL            IDS_BASE + 26
#define IDS_HELP_USING              IDS_BASE + 27
#define IDS_GENERAL_DESC            IDS_BASE + 28
#define IDS_HELP_TUTORIAL           IDS_BASE + 29
#define IDS_HELP_PRODINFO           IDS_BASE + 30
#define IDS_OPEN                    IDS_BASE + 31
#define IDS_ERROR_HELP_ASSOC        IDS_BASE + 32


/* Message ID's */
#define UM_BASE                     9000
#define UM_FILEERROR                9001
#define UM_FILEOPENED               UM_BASE + 2


/*------------------*/
/* Type definitions */
/*------------------*/

/* Window instance data */
typedef struct
   {
    HWND   hwnd;        
    HAB    hab;         
    CHAR   szFileName[CCHMAXPATH];           /* Name of last file opened */
    CHAR   szText[BUFFERSIZE + CCHMAXPATH];  /* Text displayed on window */
   } WINDOWINFO, *PWINDOWINFO;


/*---------------------*/
/* Function Prototypes */
/*---------------------*/
int              main              (int argc, char * argv[]);

MRESULT APIENTRY fnClientWndProc   (HWND, ULONG, MPARAM, MPARAM);

VOID    _Optlink fnOpenThread      (PVOID);

MRESULT APIENTRY fnProdInfoWndProc (HWND, ULONG, MPARAM, MPARAM);

MRESULT EXPENTRY fnFileOpenDlgProc (HWND, ULONG, MPARAM, MPARAM);

MRESULT EXPENTRY fnSaveasDlgProc   (HWND, ULONG, MPARAM, MPARAM);

VOID    APIENTRY DlgFileNotLoaded  (HWND, PWINDOWINFO);

VOID    APIENTRY WriteText         (HWND, PWINDOWINFO, ULONG, BOOL);

VOID    APIENTRY SetupHelp         (HWND, HAB);

VOID    APIENTRY StartTutorial     (HWND, HAB);


